program berechnecoeffizientenfuerharmonischenoszillator;
uses dos,crt,ucomplex;

function fileexist(name:string):boolean;
var s:searchrec;
begin
  s.name:=name;
  findfirst(name,anyfile,s);
  fileexist:=doserror=0;
end;


const maxpunkt=255;
      maxcoeff=80;
      absmaxbild=254;
type TRect=array[0..1,0..1] of word;

     TCoeff=array[0..maxcoeff] of OComplex;

     OFilm=object
       aktname,beschreibung:string;
       typ:byte;
       negativ:boolean;
       konturanzeigen,zeigeranzeigen:boolean;
       c,c2:TCoeff;
       allecoeff:boolean;
       kontur:array[0..absmaxbild,0..2] of byte;
       konturmax,konturmaxbreite:byte;
       xmax:extended;
       aktbild:byte;
       a:ocomplex;
       s,theta,n_,varn:extended;
       aktmaxcoeff,aktmaxbild:byte;
       aktmaxpunkt:word;
       maxbild:word;
       constructor init(axmax:extended;amc,amb:byte;amp:word);
       destructor done;
       procedure coherent;
       procedure squeezed;
       procedure copycoeff;
       procedure addcoeff;
       procedure zufall;
       procedure berechne(name:string);
       procedure savecoeff(name:string);
     end;

constructor ofilm.init(axmax:extended;amc,amb:byte;amp:word);
var n:byte;
begin
  negativ:=false;
  allecoeff:=false;
  aktname:='';
  aktmaxcoeff:=amc;
  aktmaxbild:=amb;
  aktmaxpunkt:=amp;
  typ:=0;
  for n:=0 to maxcoeff do begin
    c[n].init(0,0);
    c2[n].init(0,0);
  end;
  xmax:=axmax;
  s:=0.5;
  theta:=0;
  a.gleichreim(1,1);
  aktbild:=0;
  maxbild:=0;
  fillchar(kontur,sizeof(kontur),#0);
  beschreibung:='';
  konturanzeigen:=false;
  zeigeranzeigen:=false;
end;

destructor ofilm.done;
var n:byte;
begin
end;

procedure ofilm.zufall;
var n,m:byte;
    i:extended;
begin
  typ:=4;
  randomize;
  for m:=1 to aktmaxcoeff do begin
    c[m].gleichreim(random-0.5,random-0.5);
  end;
  i:=0;
  for n:=0 to aktmaxcoeff do i:=i+c[n].sqrbetrag;
  i:=1/sqrt(i);
  for n:=0 to aktmaxcoeff do c[n].multreel(i);
end;

procedure ofilm.berechne(name:string);
var t:text;
    D: DirStr;
    Na: NameStr;
    E: ExtStr;
    n:integer;
    re,im:extended;
    aa,ab:byte;
begin
  if not fileexist(name) then exit;
  FSplit(name, D, Na, E);
  aktname:=na+'.osz';
  typ:=4;
  assign(t,name);
  reset(t);
  readln(t,beschreibung);
  readln(t,xmax,aktmaxbild,aktmaxpunkt);
  readln(t,aa,ab);
  konturanzeigen:=aa=1;
  zeigeranzeigen:=ab=1;
  n:=0;
  while not eof(t) do begin
    readln(t,re,im);
    c[n].gleichreim(re,im);
    inc(n);
  end;
  close(t);
  dec(n);
  if n<0 then exit;
  aktmaxcoeff:=n;
  savecoeff(aktname);
end;

procedure ofilm.savecoeff(name:string);
var t:text;
    D: DirStr;
    Na: NameStr;
    E: ExtStr;
    n:byte;
begin
  FSplit(name, D, Na, E);
  if e='' then name:=d+na+'.ber';
  assign(t,name);
  rewrite(t);
  writeln(t,beschreibung);
  writeln(t,xmax,' ',aktmaxbild,' ',aktmaxpunkt);
  writeln(t,byte(konturanzeigen),' ',byte(zeigeranzeigen));
  for n:=0 to aktmaxcoeff do writeln(t,c[n].re,' ',c[n].im);
  close(t);
end;


procedure ofilm.copycoeff;
begin
  move(c,c2,sizeof(c));
end;

procedure ofilm.addcoeff;
var n:byte;
    i:extended;
begin
  i:=0;
  for n:=0 to aktmaxcoeff do begin
    c[n].add(c2[n]);
    i:=i+c[n].sqrbetrag;
  end;
  i:=1/sqrt(i);
  for n:=0 to aktmaxcoeff do c[n].multreel(i);
  typ:=4;
end;


procedure ofilm.coherent;
var n:byte;
begin
  typ:=1;
  c[0].gleichreim(exp(-a.sqrbetrag/2),0);
  for n:=1 to aktmaxcoeff do begin
    c[n].gleich(a);
    c[n].mult(c[pred(n)]);
    c[n].multreel(1/sqrt(n));
  end;
end;

procedure ofilm.squeezed;
var n:byte;
    my,ny,b,h,aa:OComplex;
    i:extended;
begin
  typ:=2;
  aa.gleich(a);
  my.init(cosh(s),0);
  ny.init(0,0);
  ny.gleichphase(2*theta);
  ny.multreel(sinh(s));
  b.init(0,0);
  b.gleich(a);
  b.mult(my);
  aa.conjung;
  aa.mult(ny);
  b.add(aa);

  c[0].gleichreim(1,0);
  c[1].gleich(b);
  c[1].durch(my);
  h.init(0,0);
  for n:=2 to aktmaxcoeff do begin
    h.gleich(c[n-2]);
    h.multreel(-sqrt(n-1));
    h.mult(ny);
    c[n].gleich(b);
    c[n].mult(c[pred(n)]);
    c[n].add(h);
    c[n].durch(my);
    c[n].multreel(1/sqrt(n));
  end;
  i:=0;
  for n:=0 to aktmaxcoeff do i:=i+c[n].sqrbetrag;
  i:=1/sqrt(i);
  for n:=0 to aktmaxcoeff do c[n].multreel(i);
end;

var film:^ofilm;
    a:ocomplex;
    n:byte;
    ein:char;

begin
  new(film,init(   6,   59,  127,  127));
  film^.a.gleichreim(3,0);
  film^.s:=1;
  film^.theta:=0;
  film^.squeezed;
  film^.copycoeff;
  film^.a.gleichreim(-3,0);
  film^.s:=1;
  film^.theta:=0;
  film^.squeezed;
  film^.addcoeff;
  film^.beschreibung:='2 gequetschte Zustnde d=180';
  film^.savecoeff('2squ');
  film^.a.gleichreim(3,0);
  film^.s:=1;
  film^.theta:=0;
  film^.squeezed;
  film^.copycoeff;
  film^.a.gleichreim(3,0);
  film^.s:=1;
  film^.theta:=0;
  film^.coherent;
  film^.addcoeff;
  film^.konturanzeigen:=true;
  film^.zeigeranzeigen:=true;
  film^.beschreibung:='gequetschter und kohrenter Zustand gemischt';
  film^.savecoeff('squkoh');
  film^.konturanzeigen:=false;
  film^.zeigeranzeigen:=false;
  film^.a.gleichreim(3,0);
  film^.s:=1;
  film^.theta:=0;
  film^.squeezed;
  film^.copycoeff;
  film^.a.gleichreim(-3,0);
  film^.s:=1;
  film^.theta:=0;
  film^.coherent;
  film^.addcoeff;
  film^.beschreibung:='gequetschter & kohrenter Zustand gegenphasig';
  film^.savecoeff('squkoh2');
  film^.a.gleichreim(3,0);
  film^.s:=1;
  film^.theta:=0;
  film^.squeezed;
  film^.copycoeff;
  film^.a.gleichreim(-3,0);
  film^.s:=1;
  film^.theta:=180;
  film^.squeezed;
  film^.addcoeff;
  film^.beschreibung:='2 gequetschte Zustnde gegenphasig, d=180';
  film^.savecoeff('2squ2');
  film^.a.gleichreim(-3,0);
  film^.s:=1;
  film^.theta:=0;
  film^.squeezed;
  film^.beschreibung:='2 gequetschte Zustnde gegenphasig, d=90';
  film^.savecoeff('test');
end.