program harmonischeroszillator;
uses dos,crt,graph,unumber,ucomplex;
var maxx,maxy:integer;

{$L EGAVGA}
procedure EGAVGAdriver;external;

{$L SMALL}
procedure Small;external;

procedure grafikein;
var gd,gm:integer;
    regs:registers;
begin
  registerbgifont(@Small);
  registerbgidriver(@EGAVGAdriver);
  gd:=EGA;
  gm:=EGAHi;
  initgraph(gd,gm,'');
  maxx:=getmaxx;
  maxy:=getmaxy;
  with regs do begin
    ax:=$1001;
    bh:=63;
    intr($10,regs);
  end;
end;

procedure waitsync;
begin
  asm
         mov  dx,$3da
         mov  ah,8
  @wait4:in   al,dx
         test al,ah
         jz   @wait4
  end;
end;

const aktseite:byte=0;
procedure seitenwechsel;
begin
  waitsync;
  setactivepage(aktseite);
  aktseite:=byte( not boolean(aktseite));
  setvisualpage(aktseite);
end;

procedure schreibwechsel;
begin
  setactivepage(aktseite);
end;

procedure eineseite;
begin
  setactivepage(aktseite);
  setvisualpage(aktseite);
end;

procedure zweiseiten;
begin
  setactivepage(byte( not boolean(aktseite)));
  setvisualpage(aktseite);
end;

procedure clear;
begin
  seitenwechsel;
  setcolor(white);
  bar(0,0,maxx,maxy);
  seitenwechsel;
  bar(0,0,maxx,maxy);
end;

procedure getextended(var r:extended;s:string);
var s1:string;
    rh:extended;
    err:integer;
begin
  textcolor(lightgreen); write(s:30,'? ');
  textcolor(lightmagenta); write('[',r:8:4,']');
  readln(s1);
  if s1<>'' then begin
    val(s1,rh,err);
    if err=0 then r:=rh;
  end;
end;

procedure getbyte(var r:byte;s:string);
var s1:string;
    rh:byte;
    err:integer;
begin
  textcolor(lightgreen); write(s:30,'? ');
  textcolor(lightmagenta); write('[',r:8,']');
  readln(s1);
  if s1<>'' then begin
    val(s1,rh,err);
    if err=0 then r:=rh;
  end;
end;

procedure getword(var r:word;s:string);
var s1:string;
    rh:word;
    err:integer;
begin
  textcolor(lightgreen); write(s:30,'? ');
  textcolor(lightmagenta); write('[',r:8,']');
  readln(s1);
  if s1<>'' then begin
    val(s1,rh,err);
    if err=0 then r:=rh;
  end;
end;

function fileexist(name:string):boolean;
var s:searchrec;
begin
  s.name:=name;
  findfirst(name,anyfile,s);
  fileexist:=doserror=0;
end;

const maxpunkt=255;
      maxcoeff=80;
      absmaxbild=254;
type TRect=array[0..1,0..1] of word;
     PBild=^OBild;
     OBild=object
       p:array[0..maxpunkt] of byte;
       hp:array[0..maxpunkt] of single;
       aktmaxpunkt:byte;
       constructor init(amp:byte);
       destructor done;
       procedure show(pos:TRect;loschen:boolean;negativ:boolean);
     end;

     TCoeff=array[0..maxcoeff] of OComplex;

     OFilm=object
       aktname,beschreibung:string;
       typ:byte;
       negativ:boolean;
       konturanzeigen,zeigeranzeigen:boolean;
       c,c2:TCoeff;
       allecoeff:boolean;
       bild:array[0..absmaxbild] of PBild;
       kontur:array[0..absmaxbild,0..2] of byte;
       konturmax,konturmaxbreite:byte;
       fp,cp,kp,zp,bp:TRect;
       xmax:extended;
       aktbild:byte;
       a:ocomplex;
       s,theta,n_,varn:extended;
       aktmaxcoeff,aktmaxbild:byte;
       aktmaxpunkt:word;
       maxbild:word;
       constructor init(afp,acp,akp,azp,abp:TRect;axmax:extended;amc,amb:byte;amp:word);
       destructor done;
       procedure coherent;
       procedure squeezed;
       procedure rechne(t:byte);
       procedure calc(num:boolean);
       procedure shownext(loschen:boolean);
       procedure next;
       procedure first(anfang:byte);
       procedure showcoeff;
       procedure showkontur;
       procedure showzeiger;
       procedure beschrifte;
       procedure showskala;
       procedure save(name:string);
       procedure load(name:string);
       procedure copycoeff;
       procedure addcoeff;
       procedure berechne(name:string);
       procedure savecoeff(name:string);
     end;

constructor obild.init(amp:byte);
begin
  aktmaxpunkt:=amp;
end;

destructor obild.done;
begin
end;

procedure obild.show(pos:TRect;loschen:boolean;negativ:boolean);
var n:byte;
    xb,yb:longint;
begin
  setcolor(white);
  if loschen then bar(pos[0,0],pos[0,1],succ(pos[1,0]),succ(pos[1,1]));
  setcolor(red);
  setlinestyle(solidln,0,thickwidth);
  xb:=pos[1,0]-pos[0,0];
  yb:=pos[1,1]-pos[0,1];
{  if negativ then begin
    moveto(pos[0,0],pos[1,1]-yb*p[aktmaxpunkt] div 256);
    for n:=aktmaxpunkt downto 1 do begin
      lineto(pos[0,0]+xb*succ(aktmaxpunkt-n) div aktmaxpunkt,
             pos[1,1]-yb*p[n] div 256);
    end;
  end else begin}
    moveto(pos[0,0],pos[1,1]-yb*p[0] div 256);
    for n:=1 to aktmaxpunkt do begin
      lineto(pos[0,0]+xb*n div aktmaxpunkt,
             pos[1,1]-yb*p[n] div 256);
    end;
{  end;}
end;

constructor ofilm.init(afp,acp,akp,azp,abp:TRect;axmax:extended;amc,amb:byte;amp:word);
var n:byte;
begin
  negativ:=false;
  allecoeff:=false;
  aktname:='';
  aktmaxcoeff:=amc;
  aktmaxbild:=amb;
  aktmaxpunkt:=amp;
  typ:=0;
  for n:=0 to maxcoeff do begin
    c[n].init(0,0);
    c2[n].init(0,0);
  end;
  fp:=afp;
  cp:=acp;
  bp:=abp;
  kp:=akp;
  inc(kp[0,0],10);
  zp:=azp;
  inc(cp[0,0],40);
  dec(fp[1,1],15);
  inc(fp[0,0],35);
  xmax:=axmax;
  s:=0.5;
  theta:=0;
  a.gleichreim(1,1);
  aktbild:=0;
  maxbild:=0;
  while (memavail>20000) and (maxbild<=absmaxbild) do begin
    new(bild[maxbild],init(aktmaxpunkt));
    inc(maxbild);
  end;
  dec(maxbild);
  fillchar(kontur,sizeof(kontur),#0);
  beschreibung:='';
  konturanzeigen:=false;
  zeigeranzeigen:=false;
end;

destructor ofilm.done;
var n:byte;
begin
  for n:=0 to maxbild do dispose(bild[n],done);
end;

procedure ofilm.berechne(name:string);
var t:text;
    D: DirStr;
    Na: NameStr;
    E: ExtStr;
    n:integer;
    re,im:extended;
    aa,ab:byte;
begin
  if not (fileexist(name) or fileexist(name+'.ber')) then exit;
  FSplit(name, D, Na, E);
  if e='' then name:=d+na+'.ber';
  aktname:=na+'.osz';
  typ:=4;
  assign(t,name);
  reset(t);
  readln(t,beschreibung);
  readln(t,xmax,aktmaxbild,aktmaxpunkt);
  readln(t,aa,ab);
  konturanzeigen:=aa=1;
  zeigeranzeigen:=ab=1;
  n:=0;
  while not eof(t) do begin
    readln(t,re,im);
    c[n].gleichreim(re,im);
    inc(n);
  end;
  close(t);
  dec(n);
  if n<0 then exit;
  aktmaxcoeff:=n;
  calc(false);
  save(aktname);
end;

procedure ofilm.savecoeff(name:string);
var t:text;
    D: DirStr;
    Na: NameStr;
    E: ExtStr;
    n:byte;
begin
  FSplit(name, D, Na, E);
  if e='' then name:=d+na+'.ber';
  assign(t,name);
  rewrite(t);
  writeln(t,beschreibung);
  writeln(t,xmax,' ',aktmaxbild,' ',aktmaxpunkt);
  writeln(t,byte(konturanzeigen),' ',byte(zeigeranzeigen));
  for n:=0 to aktmaxcoeff do writeln(t,c[n].re,' ',c[n].im);
  close(t);
end;

procedure ofilm.copycoeff;
begin
  move(c,c2,sizeof(c));
end;

procedure ofilm.addcoeff;
var n:byte;
    i:extended;
begin
  i:=0;
  for n:=0 to aktmaxcoeff do begin
    c[n].add(c2[n]);
    i:=i+c[n].sqrbetrag;
  end;
  i:=1/sqrt(i);
  for n:=0 to aktmaxcoeff do c[n].multreel(i);
  typ:=4;
end;

procedure ofilm.rechne(t:byte);
var hname:string;
    gut:boolean;
    ein:char;
    D: DirStr;
    N: NameStr;
    E: ExtStr;
    al:word;
begin
  if not (t in [1..3]) then exit;
  typ:=t;
  closegraph;
  textbackground(blue);
  textcolor(yellow);
  clrscr;
  writeln('Berechnung einer Simulation des harmonischen Oszillators');
  writeln;
  writeln;
  if (typ=1) or (typ=2) then begin
    getextended(a.re,'Realteil von ');
    getextended(a.im,'Imaginaerteil von ');
    if typ=2 then begin
      getextended(s,'Quetschgrad s');
      al:=round(theta*180/pi);
      getword(al,'Winkel ');
      theta:=al*pi/180;
    end;
  end;
  getextended(xmax,'Bildbreite');
  getbyte(aktmaxbild,'Anzahl Bilder');
  if aktmaxbild>maxbild then aktmaxbild:=maxbild;
  getword(aktmaxpunkt,'Anzahl Punkte');
  if aktmaxpunkt>maxpunkt then aktmaxpunkt:=maxpunkt;
  getbyte(aktmaxcoeff,'Anzahl Koeffizienten');
  if aktmaxcoeff>maxcoeff then aktmaxcoeff:=maxcoeff;
  gut:=false;
  while not gut do begin
    textcolor(lightgreen);
    write('Dateiname':30,'? ');
    textcolor(lightmagenta);
    write('[',aktname,'] ');
    readln(hname);
    if hname<>'' then begin
      FSplit(hname, D, N, E);
      hname:=d+n+'.osz';
      if fileexist(hname) then begin
        textcolor(lightgreen);
        writeln('Datei ',hname,' existiert. berschreiben (J/N)':30,'?');
        repeat
          repeat until keypressed;
          while keypressed do ein:=upcase(readkey);
        until ein in ['J','N'];
        if ein='J' then begin
          aktname:=hname;
          gut:=true;
        end;
      end else begin
        gut:=true;
        aktname:=hname;
      end;
    end else gut:=true;
  end;
  grafikein;
  clear;
  case typ of
    1:coherent;
    2:squeezed;
  end;
  showcoeff;
  beschrifte;
  showskala;
  seitenwechsel;
  showcoeff;
  beschrifte;
  showskala;
  calc(t=3);
  save(aktname);
end;

{procedure ofilm.zufall;
var n,m:byte;
    i:extended;
begin
  typ:=4;
  randomize;
  for m:=1 to aktmaxcoeff do begin
    c[m].gleichreim(random-0.5,random-0.5);
  end;
  i:=0;
  for n:=0 to aktmaxcoeff do i:=i+c[n].sqrbetrag;
  i:=1/sqrt(i);
  for n:=0 to aktmaxcoeff do c[n].multreel(i);
end;}

procedure ofilm.coherent;
var n:byte;
begin
  typ:=1;
  c[0].gleichreim(exp(-a.sqrbetrag/2),0);
  for n:=1 to aktmaxcoeff do begin
    c[n].gleich(a);
    c[n].mult(c[pred(n)]);
    c[n].multreel(1/sqrt(n));
  end;
end;

procedure ofilm.squeezed;
var n:byte;
    my,ny,b,h,aa:OComplex;
    i:extended;
begin
  typ:=2;
  aa.gleich(a);
  my.init(cosh(s),0);
  ny.init(0,0);
  ny.gleichphase(2*theta);
  ny.multreel(sinh(s));
  b.init(0,0);
  b.gleich(a);
  b.mult(my);
  aa.conjung;
  aa.mult(ny);
  b.add(aa);

  c[0].gleichreim(1,0);
  c[1].gleich(b);
  c[1].durch(my);
  h.init(0,0);
  for n:=2 to aktmaxcoeff do begin
    h.gleich(c[n-2]);
    h.multreel(-sqrt(n-1));
    h.mult(ny);
    c[n].gleich(b);
    c[n].mult(c[pred(n)]);
    c[n].add(h);
    c[n].durch(my);
    c[n].multreel(1/sqrt(n));
  end;
  i:=0;
  for n:=0 to aktmaxcoeff do i:=i+c[n].sqrbetrag;
  i:=1/sqrt(i);
  for n:=0 to aktmaxcoeff do c[n].multreel(i);
end;

procedure ofilm.calc(num:boolean);
var n,m,l,aktmaxpos,aktmaxbreite:byte;
    t,x,akt,max,aktmax:extended;
    aktcoeff:TCoeff;
    h,g,phase:ocomplex;
    i:extended;
begin
  i:=0;
  for n:=0 to aktmaxcoeff do i:=i+c[n].sqrbetrag;
  i:=1/sqrt(i);
  for n:=0 to aktmaxcoeff do c[n].multreel(i);
  phase.init(0,0);
  max:=0;
  for m:=0 to aktmaxcoeff do aktcoeff[m].init(0,0);
  for n:=0 to aktmaxbild do begin
    if num then begin
      typ:=3;
      for m:=0 to aktmaxcoeff do c[m].gleichreim(0,0);
      c[n].gleichreim(1,0);
    end;
    t:=2*pi/succ(aktmaxbild)*n;
    for m:=0 to aktmaxcoeff do begin
      aktcoeff[m].gleich(c[m]);
      phase.gleichphase(-m*t);
      aktcoeff[m].mult(phase);
    end;
    aktmax:=0;
    aktmaxpos:=0;
    for m:=0 to aktmaxpunkt do begin
      x:=-xmax+2*xmax*m/aktmaxpunkt;
      h.init(0,0);
      g.init(0,0);
      for l:=0 to aktmaxcoeff do begin
        g.gleich(aktcoeff[l]);
        g.multreel(number(l,x));
        h.add(g);
      end;
      bild[n]^.hp[m]:=h.sqrbetrag;
      bild[n]^.p[m]:=round(h.sqrbetrag*128);
      if max<bild[n]^.hp[m] then max:=bild[n]^.hp[m];
      if aktmax<bild[n]^.hp[m] then begin
        aktmax:=bild[n]^.hp[m];
        aktmaxpos:=m;
      end;
    end;
    kontur[n,1]:=longint(aktmaxpos)*255 div aktmaxpunkt;
    m:=1;
    aktmax:=aktmax/2;
    while (m<aktmaxpunkt) and (bild[n]^.hp[m]<aktmax) do inc(m);
    if (m<=aktmaxpunkt) then begin
      if bild[n]^.hp[pred(m)]<aktmax
      then kontur[n,0]:=round((m-(bild[n]^.hp[m]-aktmax)/(bild[n]^.hp[m]-bild[n]^.hp[pred(m)]))/aktmaxpunkt*255)
      else kontur[n,0]:=0;
      while (m<aktmaxpunkt) and (bild[n]^.hp[m]>aktmax) do inc(m);
      if (m<=aktmaxpunkt) then begin
        if bild[n]^.hp[m]<aktmax
        then kontur[n,2]:=round((m-(bild[n]^.hp[m]-aktmax)/(bild[n]^.hp[m]-bild[n]^.hp[pred(m)]))/aktmaxpunkt*255)
        else kontur[n,2]:=255;
      end else kontur[n,2]:=255;
    end else kontur[n,0]:=0;
    bild[n]^.aktmaxpunkt:=aktmaxpunkt;
    bild[n]^.show(fp,true,false);
    seitenwechsel;
  end;
  for n:=0 to aktmaxbild do begin
    {kontur[n+succ(aktmaxbild),0]:=255-kontur[n,2];
    kontur[n+succ(aktmaxbild),1]:=255-kontur[n,1];
    kontur[n+succ(aktmaxbild),2]:=255-kontur[n,0];}
    for m:=0 to aktmaxpunkt do bild[n]^.p[m]:=round(bild[n]^.hp[m]/Max*255);
  end;
  konturmax:=0;
  aktmaxpos:=0;
  konturmaxbreite:=0;
  aktmaxbreite:=0;
  for n:=0 to {pred(2*succ(}aktmaxbild{))} do begin
    if abs(kontur[n,1]-127)>aktmaxpos then begin
      konturmax:=n;
      aktmaxpos:=abs(kontur[n,1]-127);
    end;
    if (kontur[n,1]-kontur[n,0])>aktmaxbreite then begin
      konturmaxbreite:=n;
      aktmaxbreite:=kontur[n,1]-kontur[n,0];
    end;
  end;
  n_:=0;
  varn:=0;
  for n:=0 to aktmaxcoeff do begin
    n_:=n_+n*c[n].sqrbetrag;
    varn:=varn+sqr(word(n))*c[n].sqrbetrag;
  end;
  varn:=varn-sqr(n_);
end;

procedure ofilm.showkontur;
var n:byte;

  function x(ax:byte):integer;
  begin
    x:=kp[0,0]+longint(kp[1,0]-kp[0,0])*ax div ({2*}succ(aktmaxbild));
  end;

  function y(ay:byte):integer;
  begin
    y:=kp[1,1]-longint(kp[1,1]-kp[0,1])*ay div 256;
  end;

begin
  setcolor(white);
  bar(kp[0,0]-10,kp[0,1],kp[1,0],succ(kp[1,1]));
  if not ((typ=1) or (typ=2) or ((typ=4) and konturanzeigen)) then exit;
  setcolor(black);
  setlinestyle(solidln,0,thickwidth);
  line(kp[0,0],(kp[0,1]+kp[1,1]) div 2,kp[1,0],(kp[0,1]+kp[1,1]) div 2);
  line(kp[0,0],kp[0,1],kp[0,0],kp[1,1]);
  settextstyle(smallfont,horizdir,4);
  outtextxy(kp[0,0]-9,kp[0,1],'E');
  outtextxy(kp[1,0]-10,(kp[0,1]+kp[1,1]) div 2,'');
  setcolor(red);
  moveto(x(0),y(kontur[0,0]));
  for n:=1 to {pred(2*succ(}aktmaxbild{))} do lineto(x(n),y(kontur[n,0]));
  lineto(x({2*}succ(aktmaxbild)),y(kontur[0,0]));
  setcolor(green);
  moveto(x(0),y(kontur[0,1]));
  for n:=1 to {pred(2*Succ(}aktmaxbild{))} do lineto(x(n),y(kontur[n,1]));
  lineto(x({2*}succ(aktmaxbild)),y(kontur[0,1]));
  setcolor(red);
  moveto(x(0),y(kontur[0,2]));
  for n:=1 to {pred(2*succ(}aktmaxbild{))} do lineto(x(n),y(kontur[n,2]));
  lineto(x({2*}succ(aktmaxbild)),y(kontur[0,2]));
end;

procedure ofilm.showzeiger;
var minbreite:byte;
    dx,dy,abreite,bbreite,l,b,ax,ay:single;
    xnull,ynull:integer;

  function x(ax:single):integer;
  begin
    x:=xnull+round(dx*ax/xmax);
  end;

  function y(ay:single):integer;
  begin
    y:=ynull-round(dy*ay/xmax);
  end;

  procedure ellipse(cx,cy,d,a,b:single);
  var hx,hy,ax,ay,t:extended;

    procedure pos;
    begin
      ax:=a*cos(t);
      ay:=b*sin(t);
      hx:=cx+ax*cos(d)-ay*sin(d);
      hy:=cy+ax*sin(d)+ay*cos(d);
    end;

  begin
{    sound(100);}
    t:=0;
    pos;
    moveto(x(hx),y(hy));
    while t<(2*pi+0.1) do begin
      pos;
      lineto(x(hx),y(hy));
      t:=t+0.1;
    end;
{    sound(1000);}
  end;

begin
  dx:=(zp[1,0]-zp[0,0])/2;
  dy:=(zp[1,1]-zp[0,1])/2;
  xnull:=(zp[0,0]+zp[1,0]) div 2;
  ynull:=(zp[0,1]+zp[1,1]) div 2;
  setcolor(white);
  bar(pred(zp[0,0]),zp[0,1],zp[1,0],zp[1,1]);
  if not ((typ=1) or (typ=2) or ((typ=4) and zeigeranzeigen)) then exit;
  setcolor(black);
  setlinestyle(solidln,0,thickwidth);
  line(x(-xmax),y(0),x(xmax),y(0));
  line(x(0),y(-xmax),x(0),y(xmax));
{  sound(300);}
  l:=(kontur[konturmax,1]-127)/127*xmax;
{  sound(350);}
  b:=konturmax/succ(aktmaxbild)*2*pi;
  setcolor(green);
  ax:=l*cos(b);
  ay:=l*sin(b);
{  sound(400);}
  line(x(0),y(0),x(ax),y(ay));
  setcolor(red);
  abreite:=(kontur[konturmaxbreite,1]-kontur[konturmaxbreite,0])*xmax/128;
{  sound(450);}
  minbreite:=konturmaxbreite+succ(aktmaxbild) div 4{2};
{  sound(200);}
  if minbreite>{pred(2*succ(}aktmaxbild{))} then dec(minbreite,{2*}succ(aktmaxbild));
  bbreite:=(kontur[minbreite,1]-kontur[minbreite,0])*xmax/128;
{  sound(250);}
  Ellipse(ax,ay,(konturmax-konturmaxbreite)/succ(aktmaxbild)*2*pi,abreite,bbreite);
{  nosound;}
end;

procedure ofilm.beschrifte;
var t,h:string;
begin
  setcolor(white);
  bar(bp[0,0],bp[0,1],bp[1,0],bp[1,1]);
  settextstyle(smallfont,horizdir,6);
  setcolor(black);
  case typ of
    1:begin
        t:='Kohrenter Zustand =';
        if (abs(a.re)>0.05) or (abs(a.im)<0.05) then begin
          str(abs(a.re):2:1,h);
          if a.re>0 then t:=t+' '+h else t:=t+'-'+h;
        end;
        if abs(a.im)>0.05 then begin
          str(abs(a.im):2:1,h);
          if a.im>0 then t:=t+'+i'+h else t:=t+'-i'+h;
        end;
      end;
    2:begin
        t:='Gequetschter Zustand =';
        if (abs(a.re)>0.05) or (abs(a.im)<0.05) then begin
          str(abs(a.re):2:1,h);
          if a.re>0 then t:=t+' '+h else t:=t+'-'+h;
        end;
        if abs(a.im)>0.05 then begin
          str(abs(a.im):2:1,h);
          if a.im>0 then t:=t+'+i'+h else t:=t+'-i'+h;
        end;
        str(abs(s):2:1,h);
        if s>0 then t:=t+' r= '+h else t:=t+' r=-'+h;
        str(theta/(2*pi)*360:3:0,h);
        t:=t+' ='+h+#248;
      end;
    3:begin
        t:='Energieeigenzustand zu n=';
        str(aktbild:2,h);
        t:=t+h;
        varn:=0;
        n_:=aktbild;
      end;
    4:t:=beschreibung;
    else begin
      t:='';
    end;
  end;
  outtextxy(bp[0,0],bp[0,1],t);
  t:='<N>=';
  str(n_:2:1,h);
  t:=t+h+' Var(N)=';
  str(varn:2:1,h);
  t:=t+h;
  outtextxy(bp[0,0]+460,bp[0,1],t);
end;

procedure ofilm.showskala;
begin
  setcolor(white);
  bar(fp[0,0]-35,fp[0,1],fp[1,0],fp[1,1]+15);
  setcolor(black);
  setlinestyle(solidln,0,Thickwidth);
  line(fp[0,0]-2,fp[1,1]+3,fp[1,0],fp[1,1]+3);
  line(fp[0,0]-2,fp[0,1],fp[0,0]-2,fp[1,1]+3);
  line((fp[0,0]+fp[1,0]) div 2,fp[1,1]+3,(fp[0,0]+fp[1,0]) div 2,fp[1,1]+15);
  settextstyle(smallfont,horizdir,4);
  outtextxy(fp[0,0]-34,fp[0,1]+5,'p(E)');
  outtextxy(fp[1,0]-20,fp[1,1]+5,'E');
  outtextxy((fp[0,0]+fp[1,0]) div 2+5,fp[1,1]+3,'0');
end;

procedure ofilm.shownext(loschen:boolean);
begin
  bild[aktbild]^.show(fp,loschen,negativ);
  inc(aktbild);
  if aktbild>aktmaxbild then begin
    aktbild:=0;
{    negativ:=not negativ;}
  end;
end;

procedure ofilm.first(anfang:byte);
begin
  aktbild:=anfang mod aktmaxbild;
end;

procedure ofilm.next;
begin
  inc(aktbild);
  if aktbild>aktmaxbild then begin
    aktbild:=0;
{    negativ:=not negativ;}
  end;
end;

procedure ofilm.showcoeff;
var d,max,min:extended;
    null:integer;
    n,anzahl:byte;
    dy:longint;

  function y(h:extended):integer;
  var ay:integer;
  begin
    ay:=cp[1,1]-(round((dy*h)/(max-min))+null);
    y:=ay;
  end;

begin
  setcolor(white);
  bar(cp[0,0]-40,cp[0,1],cp[1,0],cp[1,1]);
  if typ=3 then exit;
  if allecoeff then anzahl:=(cp[1,0]-cp[0,0]) div 20
  else anzahl:=(cp[1,0]-cp[0,0]) div 6;
  if anzahl>aktmaxcoeff then anzahl:=aktmaxcoeff;
  dy:=cp[1,1]-cp[0,1];
  setlinestyle(solidln,0,thickwidth);
  setcolor(black);
  max:=0;
  min:=0;
  for n:=0 to anzahl do begin
    if allecoeff then begin
      if c[n].re>max then max:=c[n].re;
      if c[n].im>max then max:=c[n].im;
      if c[n].re<min then min:=c[n].re;
      if c[n].im<min then min:=c[n].im;
    end;
    if c[n].sqrbetrag>max then max:=c[n].sqrbetrag;
    if c[n].sqrbetrag<min then min:=c[n].sqrbetrag;
  end;
  d:=(cp[1,0]-cp[0,0])/succ(anzahl);
  null:=round((cp[1,1]-cp[0,1])/(min-max)*min);
  line(cp[0,0]-7,y(0),cp[1,0],y(0));
  line(cp[0,0]-7,cp[0,1],cp[0,0]-7,cp[1,1]);
  settextstyle(smallfont,horizdir,4);
  if ((y(0)+15)<cp[1,1]) then outtextxy(cp[1,0]-10,y(0)+2,'n')
  else outtextxy(cp[1,0]-10,y(0)-15,'n');
  if allecoeff then begin
    setcolor(green);
    outtextxy(cp[0,0]-39,cp[0,1]+20,'Re(c)');
    setcolor(red);
    outtextxy(cp[0,0]-39,cp[0,1]+35,'Im(c)');
  end;
  setcolor(blue);
  outtextxy(cp[0,0]-39,cp[0,1]+5,'c');
  outtextxy(cp[0,0]-29,cp[0,1]+2,'');
  for n:=0 to anzahl do begin
    if allecoeff then begin
      setcolor(green);
      line(cp[0,0]+round(d*n),y(0),cp[0,0]+round(d*n),y(c[n].re));
      setcolor(red);
      line((cp[0,0]+round(d*n))+4,y(0),(cp[0,0]+round(d*n))+4,y(c[n].im));
    end;
    setcolor(blue);
    line((cp[0,0]+round(d*n))+8,y(0),(cp[0,0]+round(d*n))+8,y(c[n].sqrbetrag));
  end;
end;

const header:array[0..29] of char=('H','a','r','m','o','n','i','s','c','h','e','r',' ',
  'O','s','z','i','l','l','a','t','o','r',' ','F','i','l','m',#$1A,#$1A);
procedure ofilm.save(name:string);
var f:file;
    n:byte;
    D: DirStr;
    Na: NameStr;
    E: ExtStr;
begin
  FSplit(name, D, Na, E);
  name:=na+'.osz';
  aktname:=name;
  assign(f,name);
  rewrite(f,1);
  blockwrite(f,header,sizeof(header));
  blockwrite(f,aktmaxcoeff,sizeof(aktmaxcoeff));
  blockwrite(f,aktmaxbild,sizeof(aktmaxbild));
  blockwrite(f,aktmaxpunkt,sizeof(aktmaxpunkt));
  blockwrite(f,typ,sizeof(typ));
  if (typ=1) or (typ=2) then begin
    blockwrite(f,a.re,sizeof(a.re));
    blockwrite(f,a.im,sizeof(a.im));
    if typ=2 then begin
      blockwrite(f,theta,sizeof(theta));
      blockwrite(f,s,sizeof(s));
    end;
  end;
  if typ=4 then begin
    blockwrite(f,beschreibung,sizeof(beschreibung));
    blockwrite(f,konturanzeigen,sizeof(konturanzeigen));
    blockwrite(f,zeigeranzeigen,sizeof(zeigeranzeigen));
  end;
  blockwrite(f,xmax,sizeof(xmax));
  if typ<>3 then for n:=0 to aktmaxcoeff do begin
    blockwrite(f,c[n].re,sizeof(c[n].re));
    blockwrite(f,c[n].im,sizeof(c[n].im));
  end;
  for n:=0 to aktmaxbild do blockwrite(f,bild[n]^.p,succ(aktmaxpunkt)*sizeof(bild[n]^.p[0]));
  blockwrite(f,kontur,sizeof(kontur[0])*{2*}succ(aktmaxbild));
  blockwrite(f,konturmax,sizeof(konturmax));
  blockwrite(f,konturmaxbreite,sizeof(konturmaxbreite));
  blockwrite(f,varn,sizeof(varn));
  blockwrite(f,n_,sizeof(n_));
  close(f);
end;

procedure ofilm.load(name:string);
var f:file;
    n:byte;
    test:array[0..29] of char;
    D: DirStr;
    Na: NameStr;
    E: ExtStr;
begin
  if name='' then exit;
  FSplit(name, D, Na, E);
  name:=na+'.osz';
  aktname:=name;
  assign(f,name);
  reset(f,1);
  blockread(f,test,sizeof(header));
  if test[0]<>header[0] then begin
    writeln(name+' keine Harmonischer Oszillator Film Datei');
    close(f);
    exit;
  end;
  blockread(f,aktmaxcoeff,sizeof(aktmaxcoeff));
  blockread(f,aktmaxbild,sizeof(aktmaxbild));
  blockread(f,aktmaxpunkt,sizeof(aktmaxpunkt));
  if (aktmaxcoeff>maxcoeff) or (aktmaxbild>maxbild) or (aktmaxpunkt>maxpunkt) then begin
    writeln('Zu groer Film');
    close(f);
    exit;
  end;
  for n:=0 to aktmaxbild do bild[n]^.aktmaxpunkt:=aktmaxpunkt;
  blockread(f,typ,sizeof(typ));
  if (typ=1) or (typ=2) then begin
    blockread(f,a.re,sizeof(a.re));
    blockread(f,a.im,sizeof(a.im));
    if typ=2 then begin
      blockread(f,theta,sizeof(theta));
      blockread(f,s,sizeof(s));
    end;
  end;
  if typ=4 then begin
    blockread(f,beschreibung,sizeof(beschreibung));
    blockread(f,konturanzeigen,sizeof(konturanzeigen));
    blockread(f,zeigeranzeigen,sizeof(zeigeranzeigen));
  end;
  blockread(f,xmax,sizeof(xmax));
  if typ<>3 then for n:=0 to aktmaxcoeff do begin
    blockread(f,c[n].re,sizeof(c[n].re));
    blockread(f,c[n].im,sizeof(c[n].im));
  end;
  for n:=0 to aktmaxbild do blockread(f,bild[n]^.p,succ(aktmaxpunkt)*sizeof(bild[n]^.p[0]));
  blockread(f,kontur,sizeof(kontur[0])*{2*}succ(aktmaxbild));
  blockread(f,konturmax,sizeof(konturmax));
  blockread(f,konturmaxbreite,sizeof(konturmaxbreite));
  blockread(f,varn,sizeof(varn));
  blockread(f,n_,sizeof(n_));
  close(f);
end;

const maxeintrag=100;
type OListe=object
       film:array[0..maxeintrag] of record
         name:string;
         typ:byte;
         a:ocomplex;
         s,theta:extended;
         number:byte;
         beschreibung:string[30];
       end;
       maxanzeige:byte;
       aktpos,aktmax:shortint;
       pos:TRect;
       constructor init(apos:TRect);
       destructor done;
       procedure neu;
       procedure show;
       procedure eintrag(name:string);
       function getname(n:byte):string;
       procedure holeliste(name:string);
       procedure up(r:shortint);
     end;

procedure OListe.eintrag(name:string);
var f:file;
    n:byte;
    b:string;
    test:array[0..29] of char;
    aktmaxcoeff,aktmaxbild:byte;
    aktmaxpunkt:word;
begin
  if not fileexist(name) then exit;
  film[aktmax].name:=name;
  assign(f,name);
  reset(f,1);
  blockread(f,test,sizeof(header));
  if test[0]<>header[0] then begin
    writeln(name+' keine Harmonischer Oszillator Film Datei');
    close(f);
    exit;
  end;
  with film[aktmax] do begin
    blockread(f,aktmaxcoeff,sizeof(aktmaxcoeff));
    blockread(f,aktmaxbild,sizeof(aktmaxbild));
    blockread(f,aktmaxpunkt,sizeof(aktmaxpunkt));
    blockread(f,typ,sizeof(typ));
    if (typ=1) or (typ=2) then begin
      blockread(f,a.re,sizeof(a.re));
      blockread(f,a.im,sizeof(a.im));
      if typ=2 then begin
        blockread(f,theta,sizeof(theta));
        blockread(f,s,sizeof(s));
      end;
    end;
    if typ=4 then begin
      blockread(f,b,sizeof(b));
      beschreibung:=copy(b,1,30);
    end;
  end;
  close(f);
  inc(aktmax);
end;

constructor OListe.init(apos:TRect);
begin
  maxanzeige:=((apos[1,1]-apos[0,1]) div 10);
  pos:=apos;
  aktmax:=0;
  aktpos:=0;
  if fileexist('HARMOSZ.INI') then holeliste('HARMOSZ.INI') else neu;
end;

procedure oliste.holeliste(name:string);
var t:text;
    s:string;
    D: DirStr;
    N: NameStr;
    E: ExtStr;
begin
  assign(t,name);
  reset(t);
  while not eof(t) do begin
    readln(t,s);
    FSplit(s, D, N, E);
    eintrag(d+n+'.osz');
  end;
end;

procedure OListe.neu;
var s:searchrec;
begin
  aktpos:=0;
  aktmax:=0;
  s.name:='*.osz';
  findfirst('*.osz',anyfile,s);
  while (doserror=0) and (aktmax<maxeintrag) do begin
    eintrag(s.name);
    findnext(s);
  end;
end;

destructor OListe.done;
begin
end;

function OListe.getname(n:byte):string;
begin
  if (n+aktpos)<aktmax then getname:=film[n+aktpos].name else getname:='';
end;

procedure oliste.up(r:shortint);
var alt:shortint;
begin
  if aktmax<=maxanzeige then exit;
  alt:=aktpos;
  inc(aktpos,r*maxanzeige);
  if aktpos<0 then aktpos:=0;
  if aktpos>aktmax-maxanzeige then aktpos:=aktmax-maxanzeige;
  if alt<>aktpos then begin
    show;
    seitenwechsel;
    show;
  end;
end;

procedure OListe.show;
var t,h:string;
    max,n:byte;
begin
  setcolor(white);
  bar(pos[0,0],pos[0,1],pos[1,0],pos[1,1]);
  settextstyle(smallfont,horizdir,4);
  setcolor(green);
  outtextxy(pos[0,0],pos[0,1],'H');
  setcolor(black);
  outtextxy(pos[0,0]+10,pos[0,1],' Hilfe       /      r   ');
  if aktmax>0 then begin
    max:=aktpos+pred(maxanzeige);
    if max>pred(aktmax) then max:=pred(aktmax);
    for n:=aktpos to max do with film[n] do begin
      str(n-aktpos,t);
      setcolor(green);
      outtextxy(pos[0,0],pos[0,1]+10*succ(n-aktpos),t);
      setcolor(black);
      case typ of
        1:begin
            t:=' coherent ';
            str(abs(a.re):2:1,h);
            if a.re>0 then t:=t+' '+h else t:=t+'-'+h;
            str(abs(a.im):2:1,h);
            if a.im>0 then t:=t+'+i'+h else t:=t+'-i'+h;
          end;
        2:begin
            t:=' squeezed ';
            str(abs(a.re):2:1,h);
            if a.re>0 then t:=t+' '+h else t:=t+'-'+h;
            str(abs(a.im):2:1,h);
            if a.im>0 then t:=t+'+i'+h else t:=t+'-i'+h;
            str(abs(s):2:1,h);
            if s>0 then t:=t+'  '+h else t:=t+' -'+h;
            str(theta/(2*pi)*360:3:0,h);
            t:=t+' '+h;
          end;
        3:t:=' number';
        4:t:=' '+beschreibung;
        else begin
          str(typ:3,h);
          t:=' '+h+' ';
        end;
      end;
      outtextxy(pos[0,0]+10,pos[0,1]+10*succ(n-aktpos),t);
    end;
    setcolor(red);
    if max<>pred(aktmax) then outtextxy(pos[0,0]+8,pos[0,1]+maxanzeige*10,'*');
    if aktpos<>0 then outtextxy(pos[0,0]+8,pos[0,1]+10,'*');
  end;
end;

var film:^ofilm;
    liste:^oliste;
    a:ocomplex;
    n:byte;
    ein:char;
type tmodus=(Animation,BildfuerBild,AlleBilder,MancheBilder);
const anzahlbilder:byte=8;
      anfangsbild:byte=0;
const frec:TRect=((0,25),(450,245));    {Filmbereich     }
      crec:TRect=((0,255),(450,349));   {Koeffizienten   }
      krec:TRect=((460,20),(639,145));  {Kontur          }
      zrec:TRect=((470,150),(639,280)); {zeiger          }
      lrec:TRect=((470,280),(639,349)); {liste           }
      brec:TRect=((0,0),(639,20));      {titel           }
      modus:TModus=Animation;
      verzoegerung:word=16;
{const frec:TRect=((0,25),(400,245));   Filmbereich
      crec:TRect=((0,255),(450,349));   Koeffizienten
      krec:TRect=((410,20),(639,170));  Kontur
      zrec:TRect=((520,200),(639,280)); zeiger
      lrec:TRect=((470,280),(639,349)); list
      brec:TRect=((0,0),(639,20));      titel
      modus:TModus=Animation;
      verzoegerung:word=16;}

  procedure maske;
  begin
    zweiseiten;
    film^.showkontur;
    film^.showzeiger;
    film^.showcoeff;
    film^.beschrifte;
    film^.showskala;
    liste^.show;
    seitenwechsel;
    film^.showkontur;
    film^.showzeiger;
    film^.showcoeff;
    film^.beschrifte;
    film^.showskala;
    liste^.show;
  end;

  procedure ShowModus;
  var distanzbilder:byte;
      n:byte;
      loschen:boolean;
  begin
    case modus of
      AlleBilder:begin
        eineseite;
        for n:=0 to {2*}film^.aktmaxbild do film^.shownext(n<2);
      end;
      MancheBilder:begin
        eineseite;
        distanzbilder:=film^.aktmaxbild div anzahlbilder;
        if distanzbilder=0 then distanzbilder:=1;
        loschen:=true;
        film^.first(anfangsbild);
        for n:=0 to film^.aktmaxbild do begin
          if (n mod distanzbilder)=0 then begin
            film^.shownext(loschen);
            loschen:=false;
          end else film^.next;
        end;
      end;
    end;
  end;

  procedure Hilfe;
  begin
    closegraph;
    textbackground(blue);
    textcolor(yellow);
    clrscr;
    writeln('Simulation des harmonischen Oszillators                      Florian Schreck ''96');
    writeln;
    writeln('B Bild fr Bild anzeigen (Richtung: +,- )');
    writeln('F Film abspielen');
    writeln('A,Z {Alle/Einige [Anzahl: <,>; Anfang: (,) ]} Zwischenbilder anzeigen');
    writeln('Q neuen gequetschten Zustand berechnen');
    writeln('K neuen kohrenten Zustand berechnen');
    writeln('N Energieeigenzustaende berechnen');
    writeln('L neue Dateiliste');
    writeln(#24,' Liste hoch');
    writeln(#25,' Liste runter');
    writeln('/ langsamer * schneller');
    writeln('C auch Real und Imaginrteil der Koeffizienten anzeigen');
    writeln(#27' so schnell wie mglich');
    writeln('H Hilfe');
    writeln('W Bildschirm wei');
    writeln;
    writeln('Falls Datei HARMOSZ.INI existiert werden daraus die Namen der Anfangs zu');
    writeln('ladenden Filme gelesen. Falls Parameter angegeben, werden aus der als');
    writeln('Parameter angegebenen Datei Koeffizienten geladen und Berechnung durchgefuehrt.');
    writeln;
    writeln('aktueller Film: ',film^.aktname);
    writeln('xmax: ',film^.xmax:3:2,
            '   Bilder: ',film^.aktmaxbild,'   Punkte: ',film^.aktmaxpunkt,
            '   Koeffizienten: ',film^.aktmaxcoeff);
    repeat until keypressed;
    while keypressed do readkey;
    grafikein;
    clear;
    maske;
    ShowModus;
  end;

begin
  new(liste,init(lrec));
  grafikein;
  clear;
  a.init(2,0);                    {  xmax,coeff,bild,punkt}
  new(film,init(frec,crec,krec,zrec,brec,   6,   59,  15,  127));
  if (paramcount>0) and (fileexist(paramstr(1)) or fileexist(paramstr(1)+'.ber')) then begin
    film^.berechne(paramstr(1));
    liste^.neu;
  end else begin
    if liste^.aktmax=0 then begin
      settextstyle(smallfont,horizdir,6);
      setcolor(black);
      outtextxy(0,0,'Bitte warten, ich rechne');
      seitenwechsel;
      outtextxy(0,0,'Bitte warten, ich rechne');
      film^.squeezed;
      film^.calc(false);
      film^.save('squeeze1');
    end else film^.load(liste^.getname(0));
  end;
  maske;
  if film^.typ=3 then modus:=BildfuerBild else modus:=Animation;
  ein:='?';
  repeat
    case modus of
      Animation:begin
        film^.shownext(true);
        seitenwechsel;
      end;
      BildFuerBild:begin
        if film^.typ=3 then film^.beschrifte;
        film^.shownext(true);
        seitenwechsel;
        repeat until keypressed;
      end;
    end;
    if verzoegerung>1 then delay(verzoegerung);
    if keypressed then begin
      ein:=upcase(readkey);
      if keypressed then begin
        ein:=upcase(readkey);
        case ein of
          'H':liste^.up(-1);
          'P':liste^.up(1);
        end;
      end else begin
        if ein in ['0'..'9'] then begin
          film^.load(liste^.getname(byte(ein)-byte('0')));
          maske;
          if film^.typ=3 then begin
            modus:=BildFuerBild;
            film^.aktbild:=0;
          end else if film^.aktmaxbild<10 then begin
            modus:=AlleBilder;
            eineseite;
            for n:=0 to {2*}film^.aktmaxbild do film^.shownext(false);
          end else modus:=Animation;
        end;
        case ein of
          '-':begin
                if film^.aktbild<2 then inc(film^.aktbild,film^.aktmaxbild);
                dec(film^.aktbild,2);
              end;
          'A':begin
                if film^.typ<>3 then modus:=AlleBilder;
                ShowModus;
              end;
          'Z':begin
                if film^.typ<>3 then modus:=MancheBilder;
                ShowModus;
              end;
          '<':begin
                if film^.typ<>3 then modus:=MancheBilder;
                if anzahlbilder>1 then dec(anzahlbilder);
                ShowModus;
              end;
          '>':begin
                if film^.typ<>3 then modus:=MancheBilder;
                if anzahlbilder<255 then inc(anzahlbilder);
                ShowModus;
              end;
          '(':begin
                if film^.typ<>3 then modus:=MancheBilder;
                if anfangsbild>0 then dec(anfangsbild);
                ShowModus;
              end;
          ')':begin
                if film^.typ<>3 then modus:=MancheBilder;
                if anfangsbild<255 then inc(anfangsbild);
                ShowModus;
              end;
          'B':if film^.typ<>3 then modus:=BildFuerBild;
          'F':if film^.typ<>3 then modus:=Animation;
          'H':hilfe;
          'Q':begin
                film^.rechne(2);
                liste^.neu;
                maske;
              end;
          'K':begin
                film^.rechne(1);
                liste^.neu;
                maske;
              end;
          'N':begin
                film^.rechne(3);
                liste^.neu;
                maske;
              end;
          'L':begin
                liste^.neu;
                liste^.show;
                seitenwechsel;
                liste^.show;
              end;
          'C':begin
                film^.allecoeff:=not film^.allecoeff;
                film^.showcoeff;
                schreibwechsel;
                film^.showcoeff;
                zweiseiten;
              end;
          'W':begin
                setfillstyle(solidfill,white);
                bar(0,0,getmaxx,getmaxy);
                seitenwechsel;
                repeat until keypressed;
                while keypressed do readkey;
                maske;
                if film^.typ=3 then begin
                  modus:=BildFuerBild;
                  film^.aktbild:=0;
                end else if film^.aktmaxbild<10 then begin
                  modus:=AlleBilder;
                  eineseite;
                  for n:=0 to 2*film^.aktmaxbild do film^.shownext(false);
                end else modus:=Animation;
              end;
          '*':verzoegerung:=2*verzoegerung;
          '/':if verzoegerung>1 then verzoegerung:=verzoegerung div 2;
          #8:verzoegerung:=1;
        end;
      end;
    end;
  until ein=#27;
  dispose(liste,done);
  dispose(film,done);
  closegraph;
end.