unit ucomplex;
interface
type OComplex=object
       re,im:extended;
       constructor init(are,aim:extended);
       destructor done;
       procedure mult(b:OComplex);
       procedure multreel(b:extended);
       procedure add(b:OComplex);
       procedure durch(b:OComplex);
       function betrag:extended;
       function sqrbetrag:extended;
       procedure gleich(b:OComplex);
       procedure gleichreim(are,aim:extended);
       procedure gleichphase(a:extended);
       procedure conjung;
     end;

function sinh(x:extended):extended;
function cosh(x:extended):extended;

implementation

constructor OComplex.init(are,aim:extended);
begin
  re:=are;
  im:=aim;
end;

destructor OComplex.done;
begin
end;

procedure OComplex.mult(b:OComplex);
var hre:extended;
begin
  hre:=re*b.re-im*b.im;
  im:=im*b.re+re*b.im;
  re:=hre;
end;

procedure OComplex.multreel(b:extended);
begin
  im:=im*b;
  re:=re*b;
end;

procedure OComplex.add(b:OComplex);
begin
  re:=re+b.re;
  im:=im+b.im;
end;

procedure OComplex.durch(b:OComplex);
begin
  re:=(re*b.re+im*b.im)/(b.re*b.re+b.im*b.im);
  im:=(im*b.re-re*b.im)/(b.re*b.re+b.im*b.im);
end;

procedure OComplex.gleich(b:OComplex);
begin
  re:=b.re;
  im:=b.im;
end;

function OComplex.betrag:extended;
begin
  betrag:=sqrt(im*im+re*re);
end;

function OComplex.sqrbetrag:extended;
begin
  sqrbetrag:=im*im+re*re;
end;

procedure OComplex.gleichreim(are,aim:extended);
begin
  re:=are;
  im:=aim;
end;

procedure OComplex.gleichphase(a:extended);
begin
  re:=cos(a);
  im:=sin(a);
end;

procedure OComplex.conjung;
begin
  im:=-im;
end;

function sinh(x:extended):extended;
begin
  sinh:=(exp(x)-exp(-x))/2;
end;

function cosh(x:extended):extended;
begin
  cosh:=(exp(x)+exp(-x))/2;
end;

end.